![trick_logo](https://raw.github.com/nasa/Trick/master/trick-0.png)

The Trick Simulation Environment is developed at the NASA Johnson Space Center.
Trick's flexible feature set enables users to build applications for all phases
of space vehicle development including early vehicle design and performance
evaluation, flight software development and testing, flight vehicle dynamic
loads analysis, and virtual and hardware in the loop training.  Trick's purpose
is to provide a common set of simulation capabilities allowing the domain experts
to concentrate on their domain specific models, rather than simulation-specific
functions like an job ordering, input file processing, or data recording.

### Installing Trick

The [Installing Trick](https://github.com/nasa/Trick/wiki/Installing-Trick)
wiki page includes instructions to install Trick.

### User's Guide

The full [User's Guide](https://github.com/nasa/Trick/wiki/Users-Guide) is in
the wiki pages.

### Tutorial

The [Trick Tutorial](https://github.com/nasa/Trick/wiki/TutorialHome)
is located in share/doc/trick/Tutorial. Markdown and PDF versions are available.

### Related Projects that use Trick

* The [Input Device Framework (IDF)](https://github.com/nasa/IDF)  
* [trick_variable_server_connection](https://github.com/SMASH-Lab/trick_variable_server_connection)

### License

Trick is released under the NASA Open Source Agreement Version 1.3 [license](LICENSE).
