/*
PURPOSE:
    (Conversion constants for source and input files.)
PROGRAMMERS:
    (((Robert W. Bailey) (LinCom Corp) (September 1990) (Initial Release.)))
*/

#ifndef CONSTANT_H
#define CONSTANT_H


#define DTR       (0.0174532925199433)  /* degrees to radians           */
#define RTD       (57.29577951308231)   /* radians to degrees           */
#define INTOM     (0.0254)              /* inches to meters             */
#define MTOIN     (39.370079)           /* meters to inches             */
#define FTOM      (0.3048)              /* feet to meters               */
#define NMTOM     (1852.0)              /* nautical miles to meters     */
#define MTF       (3.28083989501312336) /* meters to feet               */
#define LBFTON    (4.4482216152605)     /* pound-force to newtons       */
#define LBTOKG    (0.4535923697760192)  /* pound-mass to kilograms      */
#define SLFTOKGM  (1.355817947661907)   /* slug-ft**2 to kilogram-m**2  */
#define KGTOLB    (2.204622622937404)   /* kilograms to pound-mass      */
#define NMTOFP    (0.7375621492772654)  /* newton-meters to foot-pounds */
#define SLTOLB    (32.17404855643046)   /* slugs to pounds              */
#define SLTOKG    (14.5939029372064)    /* slugs to kilograms           */


#endif
